org.springframework.orm.jpa

## Class JpaTransactionManager

- java.lang.Object
- - org.springframework.transaction.support.AbstractPlatformTransactionManager
  - - org.springframework.orm.jpa.JpaTransactionManager

- All Implemented Interfaces:
    Serializable, Aware, BeanFactoryAware, InitializingBean, PlatformTransactionManager, ResourceTransactionManager

      public class JpaTransactionManager
      extends AbstractPlatformTransactionManager
      implements ResourceTransactionManager, BeanFactoryAware, InitializingBean

  `PlatformTransactionManager` implementation for a single JPA `EntityManagerFactory`. Binds a JPA EntityManager from the specified factory to the thread, potentially allowing for one thread-bound EntityManager per factory. `SharedEntityManagerCreator` and `JpaTemplate` are aware of thread-bound entity managers and participate in such transactions automatically. Using either is required for JPA access code supporting this transaction management mechanism.

  This transaction manager is appropriate for applications that use a single JPA EntityManagerFactory for transactional data access. JTA (usually through `JtaTransactionManager`) is necessary for accessing multiple transactional resources within the same transaction. Note that you need to configure your JPA provider accordingly in order to make it participate in JTA transactions.

  This transaction manager also supports direct DataSource access within a transaction (i.e. plain JDBC code working with the same DataSource). This allows for mixing services which access JPA and services which use plain JDBC (without being aware of JPA)! Application code needs to stick to the same simple Connection lookup pattern as with `DataSourceTransactionManager` (i.e. `DataSourceUtils.getConnection(javax.sql.DataSource)` or going through a `TransactionAwareDataSourceProxy`). Note that this requires a vendor-specific `JpaDialect` to be configured.

  Note: To be able to register a DataSource's Connection for plain JDBC code, this instance needs to be aware of the DataSource (`setDataSource(javax.sql.DataSource)`). The given DataSource should obviously match the one used by the given EntityManagerFactory. This transaction manager will autodetect the DataSource used as known connection factory of the EntityManagerFactory, so you usually don't need to explicitly specify the "dataSource" property.

  On JDBC 3.0, this transaction manager supports nested transactions via JDBC 3.0 Savepoints. The `AbstractPlatformTransactionManager.setNestedTransactionAllowed(boolean)` "nestedTransactionAllowed"} flag defaults to "false", though, as nested transactions will just apply to the JDBC Connection, not to the JPA EntityManager and its cached objects. You can manually set the flag to "true" if you want to use nested transactions for JDBC access code which participates in JPA transactions (provided that your JDBC driver supports Savepoints). Note that JPA itself does not support nested transactions! Hence, do not expect JPA access code to semantically participate in a nested transaction.

  Since:
    2.0
  Author:
    Juergen Hoeller
  See Also:
    `setEntityManagerFactory(javax.persistence.EntityManagerFactory)`, `setDataSource(javax.sql.DataSource)`, `LocalEntityManagerFactoryBean`, `JpaTemplate.execute(org.springframework.orm.jpa.JpaCallback<T>)`, `SharedEntityManagerBean`, `DataSourceUtils.getConnection(javax.sql.DataSource)`, `DataSourceUtils.releaseConnection(java.sql.Connection, javax.sql.DataSource)`, `JdbcTemplate`, `DataSourceTransactionManager`, `JtaTransactionManager`, Serialized Form

- - ### Field Summary

    - ### Fields inherited from class org.springframework.transaction.support.AbstractPlatformTransactionManager

      `logger, SYNCHRONIZATION_ALWAYS, SYNCHRONIZATION_NEVER, SYNCHRONIZATION_ON_ACTUAL_TRANSACTION`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JpaTransactionManager()` Create a new JpaTransactionManager instance.
    `JpaTransactionManager(EntityManagerFactory emf)` Create a new JpaTransactionManager instance.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `afterPropertiesSet()` Eagerly initialize the JPA dialect, creating a default one for the specified EntityManagerFactory if none set.
    `protected void` | `closeEntityManagerAfterFailedBegin(org.springframework.orm.jpa.JpaTransactionManager.JpaTransactionObject txObject)` Close the current transaction's EntityManager.
    `protected EntityManager` | `createEntityManagerForTransaction()` Create a JPA EntityManager to be used for a transaction.
    `protected void` | `doBegin(Object transaction, TransactionDefinition definition)` Begin a new transaction with semantics according to the given transaction definition.
    `protected void` | `doCleanupAfterCompletion(Object transaction)` Cleanup resources after transaction completion.
    `protected void` | `doCommit(DefaultTransactionStatus status)` Perform an actual commit of the given transaction.
    `protected Object` | `doGetTransaction()` Return a transaction object for the current transaction state.
    `protected void` | `doResume(Object transaction, Object suspendedResources)` Resume the resources of the current transaction.
    `protected void` | `doRollback(DefaultTransactionStatus status)` Perform an actual rollback of the given transaction.
    `protected void` | `doSetRollbackOnly(DefaultTransactionStatus status)` Set the given transaction rollback-only.
    `protected Object` | `doSuspend(Object transaction)` Suspend the resources of the current transaction.
    `DataSource` | `getDataSource()` Return the JDBC DataSource that this instance manages transactions for.
    `EntityManagerFactory` | `getEntityManagerFactory()` Return the EntityManagerFactory that this instance should manage transactions for.
    `JpaDialect` | `getJpaDialect()` Return the JPA dialect to use for this transaction manager.
    `Map<String,Object>` | `getJpaPropertyMap()` Allow Map access to the JPA properties to be passed to the persistence provider, with the option to add or override specific entries.
    `String` | `getPersistenceUnitName()` Return the name of the persistence unit to manage transactions for, if any.
    `Object` | `getResourceFactory()` Return the resource factory that this transaction manager operates on, e.g.
    `protected boolean` | `isExistingTransaction(Object transaction)` Check if the given transaction object indicates an existing transaction (that is, a transaction which has already started).
    `void` | `setBeanFactory(BeanFactory beanFactory)` Retrieves an EntityManagerFactory by persistence unit name, if none set explicitly.
    `void` | `setDataSource(DataSource dataSource)` Set the JDBC DataSource that this instance should manage transactions for.
    `void` | `setEntityManagerFactory(EntityManagerFactory emf)` Set the EntityManagerFactory that this instance should manage transactions for.
    `void` | `setJpaDialect(JpaDialect jpaDialect)` Set the JPA dialect to use for this transaction manager.
    `void` | `setJpaProperties(Properties jpaProperties)` Specify JPA properties, to be passed into `EntityManagerFactory.createEntityManager(Map)` (if any).
    `void` | `setJpaPropertyMap(Map<String,?> jpaProperties)` Specify JPA properties as a Map, to be passed into `EntityManagerFactory.createEntityManager(Map)` (if any).
    `void` | `setPersistenceUnitName(String persistenceUnitName)` Set the name of the persistence unit to manage transactions for.
    `protected boolean` | `shouldCommitOnGlobalRollbackOnly()` This implementation returns "true": a JPA commit will properly handle transactions that have been marked rollback-only at a global level.

    - ### Methods inherited from class org.springframework.transaction.support.AbstractPlatformTransactionManager

      `commit, determineTimeout, getDefaultTimeout, getTransaction, getTransactionSynchronization, invokeAfterCompletion, isFailEarlyOnGlobalRollbackOnly, isGlobalRollbackOnParticipationFailure, isNestedTransactionAllowed, isRollbackOnCommitFailure, isValidateExistingTransaction, newTransactionStatus, prepareForCommit, prepareSynchronization, prepareTransactionStatus, registerAfterCompletionWithExistingTransaction, resume, rollback, setDefaultTimeout, setFailEarlyOnGlobalRollbackOnly, setGlobalRollbackOnParticipationFailure, setNestedTransactionAllowed, setRollbackOnCommitFailure, setTransactionSynchronization, setTransactionSynchronizationName, setValidateExistingTransaction, suspend, triggerBeforeCommit, triggerBeforeCompletion, useSavepointForNestedTransaction`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.springframework.transaction.PlatformTransactionManager

      `commit, getTransaction, rollback`

- - ### Constructor Detail

    - #### JpaTransactionManager

          public JpaTransactionManager()

      Create a new JpaTransactionManager instance. A EntityManagerFactory has to be set to be able to use it.
      See Also:
        `setEntityManagerFactory(javax.persistence.EntityManagerFactory)`

    - #### JpaTransactionManager

          public JpaTransactionManager(EntityManagerFactory emf)

      Create a new JpaTransactionManager instance.
      Parameters:
        `emf` - EntityManagerFactory to manage transactions for

  - ### Method Detail

    - #### setEntityManagerFactory

          public void setEntityManagerFactory(EntityManagerFactory emf)

      Set the EntityManagerFactory that this instance should manage transactions for.

      Alternatively, specify the persistence unit name of the target EntityManagerFactory. By default, a default EntityManagerFactory will be retrieved through finding a single unique bean of type EntityManagerFactory in the containing BeanFactory.

      See Also:
        `setPersistenceUnitName(java.lang.String)`

    - #### getEntityManagerFactory

          public EntityManagerFactory getEntityManagerFactory()

      Return the EntityManagerFactory that this instance should manage transactions for.

    - #### setPersistenceUnitName

          public void setPersistenceUnitName(String persistenceUnitName)

      Set the name of the persistence unit to manage transactions for.

      This is an alternative to specifying the EntityManagerFactory by direct reference, resolving it by its persistence unit name instead. If no EntityManagerFactory and no persistence unit name have been specified, a default EntityManagerFactory will be retrieved through finding a single unique bean of type EntityManagerFactory.

      See Also:
        `setEntityManagerFactory(javax.persistence.EntityManagerFactory)`

    - #### getPersistenceUnitName

          public String getPersistenceUnitName()

      Return the name of the persistence unit to manage transactions for, if any.

    - #### setJpaProperties

          public void setJpaProperties(Properties jpaProperties)

      Specify JPA properties, to be passed into `EntityManagerFactory.createEntityManager(Map)` (if any).

      Can be populated with a String "value" (parsed via PropertiesEditor) or a "props" element in XML bean definitions.

      See Also:
        `EntityManagerFactory.createEntityManager(java.util.Map)`

    - #### setJpaPropertyMap

          public void setJpaPropertyMap(Map<String,?> jpaProperties)

      Specify JPA properties as a Map, to be passed into `EntityManagerFactory.createEntityManager(Map)` (if any).

      Can be populated with a "map" or "props" element in XML bean definitions.

      See Also:
        `EntityManagerFactory.createEntityManager(java.util.Map)`

    - #### getJpaPropertyMap

          public Map<String,Object> getJpaPropertyMap()

      Allow Map access to the JPA properties to be passed to the persistence provider, with the option to add or override specific entries.

      Useful for specifying entries directly, for example via "jpaPropertyMap[myKey]".

    - #### setDataSource

          public void setDataSource(DataSource dataSource)

      Set the JDBC DataSource that this instance should manage transactions for. The DataSource should match the one used by the JPA EntityManagerFactory: for example, you could specify the same JNDI DataSource for both.

      If the EntityManagerFactory uses a known DataSource as connection factory, the DataSource will be autodetected: You can still explictly specify the DataSource, but you don't need to in this case.

      A transactional JDBC Connection for this DataSource will be provided to application code accessing this DataSource directly via DataSourceUtils or JdbcTemplate. The Connection will be taken from the JPA EntityManager.

      Note that you need to use a JPA dialect for a specific JPA implementation to allow for exposing JPA transactions as JDBC transactions.

      The DataSource specified here should be the target DataSource to manage transactions for, not a TransactionAwareDataSourceProxy. Only data access code may work with TransactionAwareDataSourceProxy, while the transaction manager needs to work on the underlying target DataSource. If there's nevertheless a TransactionAwareDataSourceProxy passed in, it will be unwrapped to extract its target DataSource.

      See Also:
        `EntityManagerFactoryInfo.getDataSource()`, `setJpaDialect(org.springframework.orm.jpa.JpaDialect)`, `TransactionAwareDataSourceProxy`, `DataSourceUtils`, `JdbcTemplate`

    - #### getDataSource

          public DataSource getDataSource()

      Return the JDBC DataSource that this instance manages transactions for.

    - #### setJpaDialect

          public void setJpaDialect(JpaDialect jpaDialect)

      Set the JPA dialect to use for this transaction manager. Used for vendor-specific transaction management and JDBC connection exposure.

      If the EntityManagerFactory uses a known JpaDialect, it will be autodetected: You can still explictly specify the DataSource, but you don't need to in this case.

      The dialect object can be used to retrieve the underlying JDBC connection and thus allows for exposing JPA transactions as JDBC transactions.

      See Also:
        `EntityManagerFactoryInfo.getJpaDialect()`, `JpaDialect.beginTransaction(javax.persistence.EntityManager, org.springframework.transaction.TransactionDefinition)`, `JpaDialect.getJdbcConnection(javax.persistence.EntityManager, boolean)`

    - #### getJpaDialect

          public JpaDialect getJpaDialect()

      Return the JPA dialect to use for this transaction manager.

    - #### setBeanFactory

          public void setBeanFactory(BeanFactory beanFactory)
                              throws BeansException

      Retrieves an EntityManagerFactory by persistence unit name, if none set explicitly. Falls back to a default EntityManagerFactory bean if no persistence unit specified.
      Specified by:
        `setBeanFactory` in interface `BeanFactoryAware`
      Parameters:
        `beanFactory` - owning BeanFactory (never `null`). The bean can immediately call methods on the factory.
      Throws:
        `BeansException` - in case of initialization errors
      See Also:
        `setPersistenceUnitName(java.lang.String)`

    - #### afterPropertiesSet

          public void afterPropertiesSet()

      Eagerly initialize the JPA dialect, creating a default one for the specified EntityManagerFactory if none set. Auto-detect the EntityManagerFactory's DataSource, if any.
      Specified by:
        `afterPropertiesSet` in interface `InitializingBean`

    - #### getResourceFactory

          public Object getResourceFactory()

      Description copied from interface: `ResourceTransactionManager`
      Return the resource factory that this transaction manager operates on, e.g. a JDBC DataSource or a JMS ConnectionFactory.

      This target resource factory is usually used as resource key for `TransactionSynchronizationManager`'s resource bindings per thread.

      Specified by:
        `getResourceFactory` in interface `ResourceTransactionManager`
      Returns:
        the target resource factory (never `null`)
      See Also:
        `TransactionSynchronizationManager.bindResource(java.lang.Object, java.lang.Object)`, `TransactionSynchronizationManager.getResource(java.lang.Object)`

    - #### doGetTransaction

          protected Object doGetTransaction()

      Description copied from class: `AbstractPlatformTransactionManager`
      Return a transaction object for the current transaction state.

      The returned object will usually be specific to the concrete transaction manager implementation, carrying corresponding transaction state in a modifiable fashion. This object will be passed into the other template methods (e.g. doBegin and doCommit), either directly or as part of a DefaultTransactionStatus instance.

      The returned object should contain information about any existing transaction, that is, a transaction that has already started before the current `getTransaction` call on the transaction manager. Consequently, a `doGetTransaction` implementation will usually look for an existing transaction and store corresponding state in the returned transaction object.

      Specified by:
        `doGetTransaction` in class `AbstractPlatformTransactionManager`
      Returns:
        the current transaction object
      See Also:
        `AbstractPlatformTransactionManager.doBegin(java.lang.Object, org.springframework.transaction.TransactionDefinition)`, `AbstractPlatformTransactionManager.doCommit(org.springframework.transaction.support.DefaultTransactionStatus)`, `AbstractPlatformTransactionManager.doRollback(org.springframework.transaction.support.DefaultTransactionStatus)`, `DefaultTransactionStatus.getTransaction()`

    - #### isExistingTransaction

          protected boolean isExistingTransaction(Object transaction)

      Description copied from class: `AbstractPlatformTransactionManager`
      Check if the given transaction object indicates an existing transaction (that is, a transaction which has already started).

      The result will be evaluated according to the specified propagation behavior for the new transaction. An existing transaction might get suspended (in case of PROPAGATION_REQUIRES_NEW), or the new transaction might participate in the existing one (in case of PROPAGATION_REQUIRED).

      The default implementation returns `false`, assuming that participating in existing transactions is generally not supported. Subclasses are of course encouraged to provide such support.

      Overrides:
        `isExistingTransaction` in class `AbstractPlatformTransactionManager`
      Parameters:
        `transaction` - transaction object returned by doGetTransaction
      Returns:
        if there is an existing transaction
      See Also:
        `AbstractPlatformTransactionManager.doGetTransaction()`

    - #### doBegin

          protected void doBegin(Object transaction,
                     TransactionDefinition definition)

      Description copied from class: `AbstractPlatformTransactionManager`
      Begin a new transaction with semantics according to the given transaction definition. Does not have to care about applying the propagation behavior, as this has already been handled by this abstract manager.

      This method gets called when the transaction manager has decided to actually start a new transaction. Either there wasn't any transaction before, or the previous transaction has been suspended.

      A special scenario is a nested transaction without savepoint: If `useSavepointForNestedTransaction()` returns "false", this method will be called to start a nested transaction when necessary. In such a context, there will be an active transaction: The implementation of this method has to detect this and start an appropriate nested transaction.

      Specified by:
        `doBegin` in class `AbstractPlatformTransactionManager`
      Parameters:
        `transaction` - transaction object returned by `doGetTransaction`
        `definition` - TransactionDefinition instance, describing propagation behavior, isolation level, read-only flag, timeout, and transaction name

    - #### createEntityManagerForTransaction

          protected EntityManager createEntityManagerForTransaction()

      Create a JPA EntityManager to be used for a transaction.

      The default implementation checks whether the EntityManagerFactory is a Spring proxy and unwraps it first.

      See Also:
        `EntityManagerFactory.createEntityManager()`, `EntityManagerFactoryInfo.getNativeEntityManagerFactory()`

    - #### closeEntityManagerAfterFailedBegin

          protected void closeEntityManagerAfterFailedBegin(org.springframework.orm.jpa.JpaTransactionManager.JpaTransactionObject txObject)

      Close the current transaction's EntityManager. Called after a transaction begin attempt failed.
      Parameters:
        `txObject` - the current transaction

    - #### doSuspend

          protected Object doSuspend(Object transaction)

      Description copied from class: `AbstractPlatformTransactionManager`
      Suspend the resources of the current transaction. Transaction synchronization will already have been suspended.

      The default implementation throws a TransactionSuspensionNotSupportedException, assuming that transaction suspension is generally not supported.

      Overrides:
        `doSuspend` in class `AbstractPlatformTransactionManager`
      Parameters:
        `transaction` - transaction object returned by `doGetTransaction`
      Returns:
        an object that holds suspended resources (will be kept unexamined for passing it into doResume)
      See Also:
        `AbstractPlatformTransactionManager.doResume(java.lang.Object, java.lang.Object)`

    - #### doResume

          protected void doResume(Object transaction,
                      Object suspendedResources)

      Description copied from class: `AbstractPlatformTransactionManager`
      Resume the resources of the current transaction. Transaction synchronization will be resumed afterwards.

      The default implementation throws a TransactionSuspensionNotSupportedException, assuming that transaction suspension is generally not supported.

      Overrides:
        `doResume` in class `AbstractPlatformTransactionManager`
      Parameters:
        `transaction` - transaction object returned by `doGetTransaction`
        `suspendedResources` - the object that holds suspended resources, as returned by doSuspend
      See Also:
        `AbstractPlatformTransactionManager.doSuspend(java.lang.Object)`

    - #### shouldCommitOnGlobalRollbackOnly

          protected boolean shouldCommitOnGlobalRollbackOnly()

      This implementation returns "true": a JPA commit will properly handle transactions that have been marked rollback-only at a global level.
      Overrides:
        `shouldCommitOnGlobalRollbackOnly` in class `AbstractPlatformTransactionManager`
      See Also:
        `AbstractPlatformTransactionManager.doCommit(org.springframework.transaction.support.DefaultTransactionStatus)`, `DefaultTransactionStatus.isGlobalRollbackOnly()`, `AbstractTransactionStatus.isLocalRollbackOnly()`, `TransactionStatus.setRollbackOnly()`, `UnexpectedRollbackException`, `UserTransaction.commit()`, `RollbackException`

    - #### doCommit

          protected void doCommit(DefaultTransactionStatus status)

      Description copied from class: `AbstractPlatformTransactionManager`
      Perform an actual commit of the given transaction.

      An implementation does not need to check the "new transaction" flag or the rollback-only flag; this will already have been handled before. Usually, a straight commit will be performed on the transaction object contained in the passed-in status.

      Specified by:
        `doCommit` in class `AbstractPlatformTransactionManager`
      Parameters:
        `status` - the status representation of the transaction
      See Also:
        `DefaultTransactionStatus.getTransaction()`

    - #### doRollback

          protected void doRollback(DefaultTransactionStatus status)

      Description copied from class: `AbstractPlatformTransactionManager`
      Perform an actual rollback of the given transaction.

      An implementation does not need to check the "new transaction" flag; this will already have been handled before. Usually, a straight rollback will be performed on the transaction object contained in the passed-in status.

      Specified by:
        `doRollback` in class `AbstractPlatformTransactionManager`
      Parameters:
        `status` - the status representation of the transaction
      See Also:
        `DefaultTransactionStatus.getTransaction()`

    - #### doSetRollbackOnly

          protected void doSetRollbackOnly(DefaultTransactionStatus status)

      Description copied from class: `AbstractPlatformTransactionManager`
      Set the given transaction rollback-only. Only called on rollback if the current transaction participates in an existing one.

      The default implementation throws an IllegalTransactionStateException, assuming that participating in existing transactions is generally not supported. Subclasses are of course encouraged to provide such support.

      Overrides:
        `doSetRollbackOnly` in class `AbstractPlatformTransactionManager`
      Parameters:
        `status` - the status representation of the transaction

    - #### doCleanupAfterCompletion

          protected void doCleanupAfterCompletion(Object transaction)

      Description copied from class: `AbstractPlatformTransactionManager`
      Cleanup resources after transaction completion.

      Called after `doCommit` and `doRollback` execution, on any outcome. The default implementation does nothing.

      Should not throw any exceptions but just issue warnings on errors.

      Overrides:
        `doCleanupAfterCompletion` in class `AbstractPlatformTransactionManager`
      Parameters:
        `transaction` - transaction object returned by `doGetTransaction`